Name: gpm2
Version: oct96
Release: 3
Summary: Gardens Point Modula-2 compiler
Source0: ftp://pegasus.dvz.fh-aachen.de/pub/modula/gpm/linux-elf/modula-%{version}.tar.gz
Source1: ftp://pegasus.dvz.fh-aachen.de/pub/modula/gpm/sources/libsrc.tar.gz
Source2: ftp://pegasus.dvz.fh-aachen.de/pub/modula/gpm/manuals/modula.ps.zip
Source3: modula-release.ps.zip
Patch0: gpm2-c.diff
Patch1: gpm2-modula2.diff
ExclusiveArch: i386
ExclusiveOS: linux
URL: http://www.fit.qut.edu.au/CompSci/PLAS/GPM/
Copyright: Distributable
Group: Development/Languages
BuildRoot: /tmp/%{name}-%{version}
Packager: Ian Macdonald <ianmacd@xs4all.nl>
# gpxrf requires libc.so.4
Requires: aout-libs
BuildPrereq: unzip

%changelog
* Wed Sep  8 1999  Ian Macdonald <ianmacd@xs4all.nl>
- release notes in PostScript format added
- ExclusiveArch and ExclusiveOS tags added

* Tue Sep  7 1999  Ian Macdonald <ianmacd@xs4all.nl>
- SRPM now includes sources for most of the standard and non-standard GPM
  libraries. Since RHL 6.0, we apparently need to recompile them, as gpm2
  can't link otherwise due to library mismatches. Not all of the C files
  compile cleanly, however. Those that do, we use. In the case of those that
  don't, we're stuck with the original. See the patch file for more
  information.
- symbols and libraries now have their own separate directories
- references to gpm in man pages changed to gpm2
- Requires tag added (since Red Hat 6.0, aout-libs is no longer supplied)
- BuildPrereq tag added

* Fri Sep 11 1998  Ian Macdonald <ianmacd@xs4all.nl>
- first RPM release

%description
Gardens Point Modula-2 is a new implementation of Modula-2 for 32-bit UNIX
UNIX machines.

Gardens Point Modula-2 provides a uniform Modula-2 programming environment
in multi-vendor networks, and provides unrivaled portability between
machines. The implementation is based on the emerging ISO draft standard for
the Modula-2 language and its libraries, and is fully integrated with UNIX
standards.

You will need to execute the following command (using bash) prior to
using the tools contained in this package:

export M2SYM=/usr/lib/gpm2/sym M2LIB=/usr/lib/gpm2/lib

Please also note that the compiler has been renamed gpm2 in this package
to avoid confusion with the ubiquitous mouse server called gpm.

%prep
%setup -c
mkdir manuals
cd manuals
unzip $RPM_SOURCE_DIR/modula.ps.zip
unzip $RPM_SOURCE_DIR/modula-release.ps.zip
cd ..
mkdir -p source/{lib,sym}
cp -p {GPM,ISO}lib/* source/lib
cp -p {GPM,ISO}sym/* source/sym
cd source
tar xzvf $RPM_SOURCE_DIR/libsrc.tar.gz
%patch0 -p 2
%patch1 -p 2
cd msrc
for i in *.mpp
  do mv $i ${i%mpp}mod
done

%build
rm -rf $RPM_BUILD_ROOT
#
# Modula-2
#
# Compile C source
#
cd source/csrc
gcc -c -DANSI_C -Dopsys_sysV -Dlinux *.{c,S}
cp -pf *.o ../lib
cd ..
#
# Compile Modula-2 source
#
export M2SYM=$PWD/sym M2LIB=$PWD/lib
cd msrc
../../bin/gpm *.mod
cp -pf *.o ../lib
cd ../..
#
# Change all instances of gpm in the man pages to gpm2
#
cd admin
for i in *.man
  do sed -e 's/\([Gg][Pp][Mm]\)\>/\12/g' $i > ${i%man}1
done

%install
mv bin/gpm bin/gpm2
mv admin/gpm.1 admin/gpm2.1
mkdir -p $RPM_BUILD_ROOT/usr/{bin,lib/gpm2/{lib,sym},man/man1}
for i in bin/*
  do install $i $RPM_BUILD_ROOT/usr/bin
done
for i in source/lib/*
  do install $i $RPM_BUILD_ROOT/usr/lib/gpm2/lib
done
for i in source/sym/*
  do install $i $RPM_BUILD_ROOT/usr/lib/gpm2/sym
done
cd admin
for i in *.1
  do install $i $RPM_BUILD_ROOT/usr/man/man1
done
cd ..

%clean
rm -rf $RPM_BUILD_ROOT

%files
%doc README SUPPORT.DOC manuals/ sample/ admin/m2errlst.mod admin/m2errs.txt
/usr/bin/*
/usr/lib/gpm2
/usr/man/man1/*
